//------------------------------------------------------------------
// Stochastic Momentum Index developed by William Blau
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern int  SMIPeriod1     = 13;
extern int  SMIPeriod2     = 25;
extern int  SMIPeriod3     =  2;
extern int  SignalPeriod   =  5;
extern bool CandlesOnSlope = false;

//
//
//
//
//

double smihu[];
double smihd[];
double smihbu[];
double smihbd[];
double SMIBuffer[];
double SignalBuffer[];
double colors[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,smihu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,smihd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,smihbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,smihbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,SMIBuffer);
   SetIndexBuffer(5,SignalBuffer);
   SetIndexBuffer(6,colors);
   IndicatorShortName("SMI ("+SMIPeriod1+","+SMIPeriod2+","+SMIPeriod3+","+SignalPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][4];
#define _ema00 0
#define _ema01 1
#define _ema10 2
#define _ema11 3

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
      double alfaS = 2.0 / (1.0 + SignalPeriod);
      double alfa1 = 2.0 / (1.0 + SMIPeriod2);
      double alfa2 = 2.0 / (1.0 + SMIPeriod3);

      for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double highest = High[iHighest(NULL,0,MODE_HIGH,SMIPeriod1,i)];
         double lowest  = Low [iLowest (NULL,0,MODE_LOW ,SMIPeriod1,i)];
         double sm      = Close[i]-(highest+lowest)*0.5;
         double hl      =           highest-lowest;

            work[r][_ema00] = work[r-1][_ema00]+alfa1*(sm             -work[r-1][_ema00]);
            work[r][_ema01] = work[r-1][_ema01]+alfa2*(work[r][_ema00]-work[r-1][_ema01]);
            work[r][_ema10] = work[r-1][_ema10]+alfa1*(hl             -work[r-1][_ema10]);
            work[r][_ema11] = work[r-1][_ema11]+alfa2*(work[r][_ema10]-work[r-1][_ema11]);
            if (work[r][_ema11] != 0)
                  SMIBuffer[i] = 100.00*(work[r][_ema01]/(0.5*work[r][_ema11]));
            else  SMIBuffer[i] = 0;
            SignalBuffer[i] = SignalBuffer[i+1] + alfaS*(SMIBuffer[i]-SignalBuffer[i+1]);
            
            //
            //
            //
            //
            //
            
            smihu[i]  = EMPTY_VALUE;
            smihd[i]  = EMPTY_VALUE;
            smihbu[i] = EMPTY_VALUE;
            smihbd[i] = EMPTY_VALUE;
            colors[i] = colors[i+1];
               if (CandlesOnSlope)
               {
                  if (SMIBuffer[i]>SMIBuffer[i+1]) colors[i]= 1;
                  if (SMIBuffer[i]<SMIBuffer[i+1]) colors[i]=-1;
               }
               else
               {
                  if (SMIBuffer[i]>SignalBuffer[i]) colors[i]= 1;
                  if (SMIBuffer[i]<SignalBuffer[i]) colors[i]=-1;
               }
               
               if (colors[i] == 1)
               {
                 smihu[i]  = High[i]; 
                 smihd[i]  = Low[i];
                 smihbu[i] = MathMax(Open[i],Close[i]);
                 smihbd[i] = MathMin(Open[i],Close[i]);
               }               
               if (colors[i] == -1)
               {
                 smihu[i]  = Low[i];
                 smihd[i]  = High[i];
                 smihbu[i] = MathMin(Open[i],Close[i]);
                 smihbd[i] = MathMax(Open[i],Close[i]);
               }               
               
      }
   return(0);
}

